#!/usr/bin/env python
# -*- coding: utf-8 -*-
from gimpfu import *
from array import array

def remove_single_black_pixels(image,layer):

    image.resize(image.width+2,image.height+2,1,1)
    layer.resize_to_image_size()

    source_width=layer.width
    source_height=layer.height
    source_region=layer.get_pixel_rgn(0,0,source_width,source_height,False,False)
    target_region=layer.get_pixel_rgn(0,0,source_width,source_height,True,True)
    bpp=source_region.bpp
    source_pixels=array("B",source_region[0:source_width,0:source_height])
    target_pixels=array("B","\x00"*(source_width*source_height*bpp))

    sw=source_width*bpp
    for y in range(1,source_height-1):
        for x in range(1,source_width-1):
            pix_pos=(x+source_width*y)*bpp

            src_pos_nw=pix_pos-sw-bpp
            src_pos_n=pix_pos-sw
            src_pos_ne=pix_pos-sw+bpp
            src_pos_w=pix_pos-bpp
            src_pos_o=pix_pos
            src_pos_e=pix_pos+bpp
            src_pos_sw=pix_pos+sw-bpp
            src_pos_s=pix_pos+sw
            src_pos_se=pix_pos+sw+bpp

            Rnw,Gnw,Bnw=source_pixels[src_pos_nw:src_pos_nw+bpp]
            Rn,Gn,Bn=source_pixels[src_pos_n:src_pos_n+bpp]
            Rne,Gne,Bne=source_pixels[src_pos_ne:src_pos_ne+bpp]
            Rw,Gw,Bw=source_pixels[src_pos_w:src_pos_w+bpp]
            Ro,Go,Bo=source_pixels[src_pos_o:src_pos_o+bpp]
            Re,Ge,Be=source_pixels[src_pos_e:src_pos_e+bpp]
            Rsw,Gsw,Bsw=source_pixels[src_pos_sw:src_pos_sw+bpp]
            Rs,Gs,Bs=source_pixels[src_pos_s:src_pos_s+bpp]
            Rse,Gse,Bse=source_pixels[src_pos_se:src_pos_se+bpp]

            if Ro+Go+Bo==0:
                R_rt=Rnw+Rn+Rne+Rw+Re+Rsw+Rs+Rse
                G_rt=Gnw+Gn+Gne+Gw+Ge+Gsw+Gs+Gse
                B_rt=Bnw+Bn+Bne+Bw+Be+Bsw+Bs+Bse
                RGB_rt=R_rt+G_rt+B_rt
                if RGB_rt==6120:
                    Ro=Go=Bo=255

            target_pixels[pix_pos:pix_pos+bpp]=array('B',[Ro,Go,Bo])

    target_region[0:source_width,0:source_height]=target_pixels.tostring()
    layer.flush()
    layer.merge_shadow(True)
    layer.update(0,0,source_width,source_height)
    pdb.gimp_image_crop(image,image.width-2,image.height-2,1,1)

register(
    'python_fu_remove_single_black_pixels',
    '',
    '',
    '',
    '',
    '',
    '<Image>/Filters/Remove single black pixels',
    'RGB',
    [],
    [],
    remove_single_black_pixels)
main()
